#include <iostream>

using namespace std;

int main(void)
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, O, A, B, AB, treba;
    string grupa;

    cin >> n;
    cin >> O >> A >> B >> AB;
    for(int i = 0; i < n; i++)
        cin >> grupa >> treba;

    cout << "nemoguce\n";

    return 0;
}